diff --git a/yum/history.py b/yum/history.py
index 5385bd1..2f423d9 100644
--- a/yum/history.py
+++ b/yum/history.py
@@ -97,9 +97,58 @@ def _setupHistorySearchSQL(patterns=None, ignore_case=False):
     return (need_full, patterns, fields, False)
 # ---- horrible Copy and paste from sqlitesack ----
 
+class _YumHistPackageYumDB:
+    """ Class to pretend to be yumdb_info for history packages. """
+
+    def __init__(self, pkg):
+        self._pkg = pkg
+
+    _valid_yumdb_keys = set(["command_line",
+                             "from_repo", "from_repo_revision",
+                             "from_repo_timestamp",
+                             "installed_by", "changed_by",
+                             "reason", "releasever"])
+    def __getattr__(self, attr):
+        """ Load yumdb attributes from the history sqlite. """
+        pkg = self._pkg
+        if attr.startswith('_'):
+            raise AttributeError, "%s has no yum attribute %s" % (pkg, attr)
+
+        if attr not in self._valid_yumdb_keys:
+            raise AttributeError, "%s has no yum attribute %s" % (pkg, attr)
+
+        val = pkg._history._load_yumdb_key(pkg, attr)
+        if False and val is None:
+            raise AttributeError, "%s has no yum attribute %s" % (pkg, attr)
+
+        if val is None:
+            return None
+
+        val = str(val) or ""
+        setattr(self, attr, val)
+
+        return val
+
+    def __contains__(self, attr):
+        #  This is faster than __iter__ and it makes things fail in a much more
+        # obvious way in weird FS corruption cases like: BZ 593436
+        x = self.get(attr)
+        return x is not None
+
+    def get(self, attr, default=None):
+        """retrieve an add'l data obj"""
+
+        try:
+            res = getattr(self, attr)
+        except AttributeError:
+            return default
+        return res
+
+
 class YumHistoryPackage(PackageObject):
 
-    def __init__(self, name, arch, epoch, version, release, checksum=None):
+    def __init__(self, name, arch, epoch, version, release, checksum=None,
+                 history=None):
         self.name    = name
         self.version = version
         self.release = release
@@ -111,21 +160,69 @@ class YumHistoryPackage(PackageObject):
             self._checksums = [] # (type, checksum, id(0,1)
         else:
             chk = checksum.split(':')
-            self._checksums = [(chk[0], chk[1], 0)] # (type, checksum, id(0,1))
+            self._checksums = [(chk[0], chk[1], 1)] # (type, checksum, id(0,1))
         # Needed for equality comparisons in PackageObject
         self.repoid = "<history>"
 
+        self._history = history
+        self.yumdb_info = _YumHistPackageYumDB(self)
+
+    _valid_rpmdb_keys = set(["buildtime", "buildhost",
+                             "license", "packager",
+                             "size", "sourcerpm", "url", "vendor",
+                             # ?
+                             "committer", "committime"])
+    def __getattr__(self, attr):
+        """ Load rpmdb attributes from the history sqlite. """
+        if attr.startswith('_'):
+            raise AttributeError, "%s has no attribute %s" % (self, attr)
+
+        if attr not in self._valid_rpmdb_keys:
+            raise AttributeError, "%s has no attribute %s" % (self, attr)
+
+        val = self._history._load_rpmdb_key(self, attr)
+        if False and val is None:
+            raise AttributeError, "%s has no attribute %s" % (self, attr)
+
+        if val is None:
+            return None
+
+        val = str(val) or ""
+        setattr(self, attr, val)
+
+        return val
+
+    def _ui_from_repo(self):
+        """ This reports the repo the package is from, we integrate YUMDB info.
+            for RPM packages so a package from "fedora" that is installed has a
+            ui_from_repo of "@fedora". Note that, esp. with the --releasever
+            option, "fedora" or "rawhide" isn't authoritative.
+            So we also check against the current releasever and if it is
+            different we also print the YUMDB releasever. This means that
+            installing from F12 fedora, while running F12, would report as
+            "@fedora/13". """
+        if 'from_repo' in self.yumdb_info:
+            self._history.releasever
+            end = ''
+            if (self._history.releasever is not None and
+                'releasever' in self.yumdb_info and
+                self.yumdb_info.releasever != self._history.releasever):
+                end = '/' + self.yumdb_info.releasever
+            return '@' + self.yumdb_info.from_repo + end
+        return self.repoid
+    ui_from_repo = property(fget=lambda self: self._ui_from_repo())
+
+
 class YumHistoryPackageState(YumHistoryPackage):
-    def __init__(self, name,arch, epoch,version,release, state, checksum=None):
+    def __init__(self, name,arch, epoch,version,release, state, checksum=None,
+                 history=None):
         YumHistoryPackage.__init__(self, name,arch, epoch,version,release,
-                                   checksum)
+                                   checksum, history)
         self.done  = None
         self.state = state
 
-        self.repoid = '<history>'
 
-
-class YumHistoryRpmdbProblem(PackageObject):
+class YumHistoryRpmdbProblem:
     """ Class representing an rpmdb problem that existed at the time of the
         transaction. """
 
@@ -328,7 +425,8 @@ class YumMergedHistoryTransaction(YumHistoryTransaction):
     @staticmethod
     def _conv_pkg_state(pkg, state):
         npkg = YumHistoryPackageState(pkg.name, pkg.arch,
-                                      pkg.epoch,pkg.version,pkg.release, state)
+                                      pkg.epoch,pkg.version,pkg.release, state,
+                                      history=pkg._history)
         npkg._checksums = pkg._checksums
         npkg.done = pkg.done
         if _sttxt2stcode[npkg.state] in TS_INSTALL_STATES:
@@ -557,7 +655,7 @@ class YumMergedHistoryTransaction(YumHistoryTransaction):
 class YumHistory:
     """ API for accessing the history sqlite data. """
 
-    def __init__(self, root='/', db_path=_history_dir):
+    def __init__(self, root='/', db_path=_history_dir, releasever=None):
         self._conn = None
         
         self.conf = yum.misc.GenericHolder()
@@ -568,6 +666,9 @@ class YumHistory:
         self.conf.writable = False
         self.conf.readable = True
 
+        self.releasever = releasever
+
+        self._db_file = None
         if not os.path.exists(self.conf.db_path):
             try:
                 os.makedirs(self.conf.db_path)
@@ -580,7 +681,6 @@ class YumHistory:
                 self.conf.writable = True
 
         DBs = glob.glob('%s/history-*-*-*.sqlite' % self.conf.db_path)
-        self._db_file = None
         for d in reversed(sorted(DBs)):
             fname = os.path.basename(d)
             fname = fname[len("history-"):-len(".sqlite")]
@@ -597,7 +697,9 @@ class YumHistory:
             break
 
         if self._db_file is None:
-            self._create_db_file()
+            if not self._create_db_file():
+                # Couldn't create a db file
+                return
         
         # make an addon path for where we're going to stick 
         # random additional history info - probably from plugins and what-not
@@ -638,13 +740,15 @@ class YumHistory:
         return self._conn.cursor()
     def _commit(self):
         return self._conn.commit()
+    def _rollback(self):
+        return self._conn.rollback()
 
     def close(self):
         if self._conn is not None:
             self._conn.close()
             self._conn = None
 
-    def _pkgtup2pid(self, pkgtup, checksum=None):
+    def _pkgtup2pid(self, pkgtup, checksum=None, create=True):
         cur = self._get_cursor()
         executeSQL(cur, """SELECT pkgtupid, checksum FROM pkgtups
                            WHERE name=? AND arch=? AND
@@ -659,6 +763,9 @@ class YumHistory:
             if checksum == sql_checksum:
                 return sql_pkgtupid
         
+        if not create:
+            return None
+
         (n,a,e,v,r) = pkgtup
         (n,a,e,v,r) = (to_unicode(n),to_unicode(a),
                        to_unicode(e),to_unicode(v),to_unicode(r))
@@ -674,23 +781,28 @@ class YumHistory:
                                 (name, arch, epoch, version, release)
                                 VALUES (?, ?, ?, ?, ?)""", (n,a,e,v,r))
         return cur.lastrowid
-    def _apkg2pid(self, po):
+    def _apkg2pid(self, po, create=True):
         csum = po.returnIdSum()
         if csum is not None:
             csum = "%s:%s" % (str(csum[0]), str(csum[1]))
-        return self._pkgtup2pid(po.pkgtup, csum)
-    def _ipkg2pid(self, po):
+        return self._pkgtup2pid(po.pkgtup, csum, create)
+    def _ipkg2pid(self, po, create=True):
         csum = None
         yumdb = po.yumdb_info
         if 'checksum_type' in yumdb and 'checksum_data' in yumdb:
             csum = "%s:%s" % (yumdb.checksum_type, yumdb.checksum_data)
-        return self._pkgtup2pid(po.pkgtup, csum)
-    def pkg2pid(self, po):
+        return self._pkgtup2pid(po.pkgtup, csum, create)
+    def _hpkg2pid(self, po, create=False):
+        return self._apkg2pid(po, create)
+
+    def pkg2pid(self, po, create=True):
         if isinstance(po, YumInstalledPackage):
-            return self._ipkg2pid(po)
+            return self._ipkg2pid(po, create)
         if isinstance(po, YumAvailablePackage):
-            return self._apkg2pid(po)
-        return self._pkgtup2pid(po.pkgtup, None)
+            return self._apkg2pid(po, create)
+        if isinstance(po, YumHistoryPackage):
+            return self._hpkg2pid(po, create)
+        return self._pkgtup2pid(po.pkgtup, None, create)
 
     @staticmethod
     def txmbr2state(txmbr):
@@ -984,7 +1096,8 @@ class YumHistory:
                       ORDER BY name ASC, epoch ASC""", (tid,))
         ret = []
         for row in cur:
-            obj = YumHistoryPackage(row[0],row[1],row[2],row[3],row[4], row[5])
+            obj = YumHistoryPackage(row[0],row[1],row[2],row[3],row[4], row[5],
+                                    history=self)
             ret.append(obj)
         return ret
     def _old_data_pkgs(self, tid):
@@ -998,7 +1111,7 @@ class YumHistory:
         ret = []
         for row in cur:
             obj = YumHistoryPackageState(row[0],row[1],row[2],row[3],row[4],
-                                         row[7], row[5])
+                                         row[7], row[5], history=self)
             obj.done     = row[6] == 'TRUE'
             obj.state_installed = None
             if _sttxt2stcode[obj.state] in TS_INSTALL_STATES:
@@ -1018,7 +1131,8 @@ class YumHistory:
                       ORDER BY name ASC, epoch ASC""", (tid,))
         ret = []
         for row in cur:
-            obj = YumHistoryPackage(row[0],row[1],row[2],row[3],row[4], row[5])
+            obj = YumHistoryPackage(row[0],row[1],row[2],row[3],row[4], row[5],
+                                    history=self)
             ret.append(obj)
         return ret
     def _old_prob_pkgs(self, rpid):
@@ -1032,7 +1146,8 @@ class YumHistory:
                       ORDER BY name ASC, epoch ASC""", (rpid,))
         ret = []
         for row in cur:
-            obj = YumHistoryPackage(row[0],row[1],row[2],row[3],row[4], row[5])
+            obj = YumHistoryPackage(row[0],row[1],row[2],row[3],row[4], row[5],
+                                    history=self)
             obj.main = row[6] == 'TRUE'
             ret.append(obj)
         return ret
@@ -1091,7 +1206,11 @@ class YumHistory:
         if tids and len(tids) <= yum.constants.PATTERNS_INDEXED_MAX:
             params = tids = list(set(tids))
             sql += " WHERE tid IN (%s)" % ", ".join(['?'] * len(tids))
-        sql += " ORDER BY beg_ts DESC, tid ASC"
+        #  This relies on the fact that the PRIMARY KEY in sqlite will always
+        # increase with each transaction. In theory we can use:
+        # ORDER BY beg_ts DESC ... except sometimes people do installs with a
+        # system clock that is very broken, and using that screws them forever.
+        sql += " ORDER BY tid DESC"
         if limit is not None:
             sql += " LIMIT " + str(limit)
         executeSQL(cur, sql, params)
@@ -1151,6 +1270,127 @@ class YumHistory:
         assert len(ret) == 1
         return ret[0]
 
+    def _load_anydb_key(self, pkg, db, attr):
+        cur = self._get_cursor()
+        if cur is None or not self._update_db_file_3():
+            return None
+
+        pid = self.pkg2pid(pkg, create=False)
+        if pid is None:
+            return None
+
+        sql = """SELECT %(db)sdb_val FROM pkg_%(db)sdb
+                  WHERE pkgtupid=? and %(db)sdb_key=? """ % {'db' : db}
+        executeSQL(cur, sql, (pid, attr))
+        for row in cur:
+            return row[0]
+
+        return None
+
+    def _load_rpmdb_key(self, pkg, attr):
+        return self._load_anydb_key(pkg, "rpm", attr)
+    def _load_yumdb_key(self, pkg, attr):
+        return self._load_anydb_key(pkg, "yum", attr)
+
+    def _save_anydb_key(self, pkg, db, attr, val):
+        cur = self._get_cursor()
+        if cur is None or not self._update_db_file_3():
+            return None
+
+        pid = self.pkg2pid(pkg, create=False)
+        if pid is None:
+            return None
+
+        sql = """INSERT INTO pkg_%(db)sdb (pkgtupid, %(db)sdb_key, %(db)sdb_val)
+                        VALUES (?, ?, ?)""" % {'db' : db}
+        executeSQL(cur, sql, (pid, attr, to_unicode(val)))
+
+        return cur.lastrowid
+
+    def _save_rpmdb_key(self, pkg, attr, val):
+        return self._save_anydb_key(pkg, "rpm", attr, val)
+    def _save_yumdb_key(self, pkg, attr, val):
+        return self._save_anydb_key(pkg, "yum", attr, val)
+
+    def _save_rpmdb(self, ipkg):
+        """ Save all the data for rpmdb for this installed pkg, assumes
+            there is no data currently. """
+        for attr in YumHistoryPackage._valid_rpmdb_keys:
+            val = getattr(ipkg, attr, None)
+            if val is None:
+                continue
+            if not self._save_anydb_key(ipkg, "rpm", attr, val):
+                return False
+        return True
+
+    def _save_yumdb(self, ipkg):
+        """ Save all the data for yumdb for this installed pkg, assumes
+            there is no data currently. """
+        for attr in _YumHistPackageYumDB._valid_yumdb_keys:
+            val = ipkg.yumdb_info.get(attr)
+            if val is None:
+                continue
+            if not self._save_anydb_key(ipkg, "yum", attr, val):
+                return False
+        return True
+
+    def _wipe_anydb(self, pkg, db):
+        """ Delete all the data for rpmdb/yumdb for this installed pkg. """
+        cur = self._get_cursor()
+        if cur is None or not self._update_db_file_3():
+            return False
+
+        pid = self.pkg2pid(pkg, create=False)
+        if pid is None:
+            return False
+
+        sql = """DELETE FROM pkg_%(db)sdb WHERE pkgtupid=?""" % {'db' : db}
+        executeSQL(cur, sql, (pid,))
+
+        return True
+
+    def sync_alldb(self, ipkg):
+        """ Sync. all the data for rpmdb/yumdb for this installed pkg. """
+        if not self._wipe_anydb(ipkg, "rpm"):
+            return False
+        if not (self._wipe_anydb(ipkg, "yum") and
+                self._save_rpmdb(ipkg) and
+                self._save_yumdb(ipkg)):
+            self._rollback()
+            return False
+
+        self._commit()
+        return True
+
+    def _pkg_stats(self):
+        """ Some stats about packages in the DB. """
+
+        ret = {'nevrac' : 0,
+               'nevra'  : 0,
+               'nevr'   : 0,
+               'na'     : 0,
+               'rpmdb'  : 0,
+               'yumdb'  : 0,
+               }
+        cur = self._get_cursor()
+        if cur is None or not self._update_db_file_3():
+            return False
+
+        data = (('nevrac', "COUNT(*)",                      "pkgtups"),
+                ('na',     "COUNT(DISTINCT(name || arch))", "pkgtups"),
+                ('nevra',"COUNT(DISTINCT(name||version||epoch||release||arch))",
+                 "pkgtups"),
+                ('nevr',   "COUNT(DISTINCT(name||version||epoch||release))",
+                 "pkgtups"),
+                ('rpmdb',  "COUNT(DISTINCT(pkgtupid))", "pkg_rpmdb"),
+                ('yumdb',  "COUNT(DISTINCT(pkgtupid))", "pkg_yumdb"))
+
+        for key, bsql, esql in data:
+            executeSQL(cur, "SELECT %s FROM %s" % (bsql, esql))
+            for row in cur:
+                ret[key] = row[0]
+        return ret
+
     def _yieldSQLDataList(self, patterns, fields, ignore_case):
         """Yields all the package data for the given params. """
 
@@ -1220,6 +1460,48 @@ class YumHistory:
             tids.add(row[0])
         return tids
 
+    _update_ops_3 = ['''\
+\
+ CREATE TABLE pkg_rpmdb (
+     pkgtupid INTEGER NOT NULL REFERENCES pkgtups,
+     rpmdb_key TEXT NOT NULL,
+     rpmdb_val TEXT NOT NULL);
+''', '''\
+ CREATE INDEX i_pkgkey_rpmdb ON pkg_rpmdb (pkgtupid, rpmdb_key);
+''', '''\
+ CREATE TABLE pkg_yumdb (
+     pkgtupid INTEGER NOT NULL REFERENCES pkgtups,
+     yumdb_key TEXT NOT NULL,
+     yumdb_val TEXT NOT NULL);
+''', '''\
+ CREATE INDEX i_pkgkey_yumdb ON pkg_yumdb (pkgtupid, yumdb_key);
+''']
+
+# pylint: disable-msg=E0203
+    def _update_db_file_3(self):
+        """ Update to version 3 of history, rpmdb/yumdb data. """
+        if not self._update_db_file_2():
+            return False
+
+        if hasattr(self, '_cached_updated_3'):
+            return self._cached_updated_3
+
+        cur = self._get_cursor()
+        if cur is None:
+            return False
+
+        executeSQL(cur, "PRAGMA table_info(pkg_yumdb)")
+        #  If we get anything, we're fine. There might be a better way of
+        # saying "anything" but this works.
+        for ob in cur:
+            break
+        else:
+            for op in self._update_ops_3:
+                cur.execute(op)
+            self._commit()
+        self._cached_updated_3 = True
+        return True
+
     _update_ops_2 = ['''\
 \
  CREATE TABLE trans_skip_pkgs (
@@ -1307,6 +1589,8 @@ class YumHistory:
         self._cached_updated_2 = True
         return True
 
+# pylint: enable-msg=E0203
+
     def _create_db_file(self):
         """ Create a new history DB file, populating tables etc. """
 
@@ -1321,8 +1605,10 @@ class YumHistory:
             if os.path.exists(_db_file + '-journal'):
                 os.rename(_db_file  + '-journal', _db_file + '-journal.old')
         self._db_file = _db_file
+        if not self.conf.writable:
+            return False
         
-        if self.conf.writable and not os.path.exists(self._db_file):
+        if not os.path.exists(self._db_file):
             # make them default to 0600 - sysadmin can change it later
             # if they want
             fo = os.open(self._db_file, os.O_CREAT, 0600)
@@ -1374,7 +1660,10 @@ class YumHistory:
             cur.execute(op)
         for op in self._update_ops_2:
             cur.execute(op)
+        for op in self._update_ops_3:
+            cur.execute(op)
         self._commit()
+        return True
 
 # Pasted from sqlitesack
 _FULL_PARSE_QUERY_BEG = """
diff --git a/yum/i18n.py b/yum/i18n.py
index 9889bf6..17267d6 100755
--- a/yum/i18n.py
+++ b/yum/i18n.py
@@ -462,6 +462,34 @@ def str_eq(a, b):
     
     return False
     
+def exception2msg(e):
+    """Convert an exception to a message.  This function will convert
+    the exception using to_unicode, unicode, or str, whichever works correctly.
+
+    :param e: an exception
+    :return: a string representation of the exception
+    """
+
+    # DIE python DIE! Which one works:
+    # to_unicode(e.value); unicode(e); str(e); 
+    # Call this so you don't have to care.
+    try:
+        return to_unicode(e.value)
+    except:
+        pass
+
+    try:
+        return unicode(e)
+    except:
+        pass
+
+    try:
+        return to_unicode(str(e))
+    except:
+        pass
+    return "<exception failed to convert to text>"
+
+
 try: 
     '''
     Setup the yum translation domain and make _() and P_() translation wrappers
@@ -472,6 +500,13 @@ try:
     t = gettext.translation('yum', fallback=True)
     _ = t.ugettext
     P_ = t.ungettext
+
+    # we describe yum commands and options with unicode but optparse
+    # mixes this with non-unicode translations so "yum --help" may fail.
+    # It's much easier to fix this in optparse than in yum. BZ 1033416
+    import optparse
+    if optparse._ is gettext.gettext:
+        optparse._ = gettext.translation('messages', fallback=True).ugettext
 except:
     '''
     Something went wrong so we make a dummy _() wrapper there is just
diff --git a/yum/igroups.py b/yum/igroups.py
new file mode 100644
index 0000000..104112d
--- /dev/null
+++ b/yum/igroups.py
@@ -0,0 +1,310 @@
+#! /usr/bin/python -tt
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU Library General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+#
+# Copyright 2010, 2012 Red Hat
+#
+# James Antill <james@fedoraproject.org>
+
+import os
+import fnmatch
+import re
+
+def _open_no_umask(*args):
+    """ Annoying people like to set umask's for root, which screws everything
+        up for user readable stuff. """
+    oumask = os.umask(022)
+    try:
+        ret = open(*args)
+    finally:
+        os.umask(oumask)
+
+    return ret
+
+def _makedirs_no_umask(*args):
+    """ Annoying people like to set umask's for root, which screws everything
+        up for user readable stuff. """
+    oumask = os.umask(022)
+    try:
+        ret = os.makedirs(*args)
+    finally:
+        os.umask(oumask)
+
+    return ret
+
+class InstalledGroup(object):
+    def __init__(self, gid):
+        self.gid       = gid
+        self.pkg_names = set()
+        self.environment = None
+
+    def __cmp__(self, other):
+        if other is None:
+            return 1
+        return cmp(self.gid, other.gid)
+
+    def _additions(self, pkg_names):
+        pkg_names = set(pkg_names)
+        return sorted(pkg_names.difference(self.pkg_names))
+
+    def _removals(self, pkg_names):
+        pkg_names = set(pkg_names)
+        return sorted(pkg_names.difference(self.pkg_names))
+
+    groupid = property(fget=lambda self: self.gid,
+                      fset=lambda self, value: setattr(self, "gid", value),
+                      fdel=lambda self: setattr(self, "gid", None),
+                      doc="Compat. to treat comps groups/igroups the same")
+
+
+
+class InstalledEnvironment(object):
+    def __init__(self, evgid):
+        self.evgid     = evgid
+        self.grp_names = set()
+
+    def __cmp__(self, other):
+        if other is None:
+            return 1
+        return cmp(self.evgid, other.evgid)
+
+    def _additions(self, grp_names):
+        grp_names = set(grp_names)
+        return sorted(grp_names.difference(self.grp_names))
+
+    def _removals(self, grp_names):
+        grp_names = set(grp_names)
+        return sorted(grp_names.difference(self.grp_names))
+
+    environmentid = property(fget=lambda self: self.evgid,
+                      fset=lambda self, value: setattr(self, "evgid", value),
+                      fdel=lambda self: setattr(self, "evgid", None),
+                      doc="Compat. to treat comps groups/igroups the same")
+
+
+class InstalledGroups(object):
+    def __init__(self, db_path):
+        self.groups   = {}
+        self.changed  = False
+        self.environments = {}
+
+        self._read_pkg_grps(db_path)
+        self._read_grp_grps(db_path)
+
+    def _read_pkg_grps(self, db_path):
+        self.filename = db_path + "/installed"
+        if not os.access(self.filename, os.R_OK):
+            return
+
+        def _read_str(fo):
+            return fo.readline()[:-1]
+
+        fo = open(self.filename)
+        try:
+            ver = int(_read_str(fo))
+        except ValueError:
+            return
+        if ver != 1:
+            return
+
+        groups_num = int(_read_str(fo))
+        while groups_num > 0:
+            groups_num -= 1
+
+            grp = InstalledGroup(_read_str(fo))
+            self.groups[grp.gid] = grp
+
+            num = int(_read_str(fo))
+            while num > 0:
+                num -= 1
+                grp.pkg_names.add(_read_str(fo))
+
+    def _read_grp_grps(self, db_path):
+        self.grp_filename = db_path + "/environment"
+        if not os.access(self.grp_filename, os.R_OK):
+            return
+
+        def _read_str(fo):
+            return fo.readline()[:-1]
+
+        fo = open(self.grp_filename)
+        ver = int(_read_str(fo))
+        if ver != 1:
+            return
+
+        groups_num = int(_read_str(fo))
+        while groups_num > 0:
+            groups_num -= 1
+
+            evgrp = InstalledEnvironment(_read_str(fo))
+            self.environments[evgrp.evgid] = evgrp
+
+            num = int(_read_str(fo))
+            while num > 0:
+                num -= 1
+                grpname = _read_str(fo)
+                memb = _read_str(fo)
+                evgrp.grp_names.add(grpname)
+                assert memb in ('true', 'false')
+                if memb == 'true':
+                    assert grpname in self.groups
+                    if grpname in self.groups:
+                        self.groups[grpname].environment = evgrp.evgid
+
+    def close(self):
+        pass
+
+    def save(self, force=False):
+        if not force and not self.changed:
+            return False
+
+        db_path = os.path.dirname(self.filename)
+        if not os.path.exists(db_path):
+            try:
+                _makedirs_no_umask(db_path)
+            except (IOError, OSError), e:
+                # some sort of useful thing here? A warning?
+                return False
+
+        if not os.access(db_path, os.W_OK):
+            return False
+
+        self._write_pkg_grps()
+        self._write_grp_grps()
+
+        self.changed = False
+
+    def _write_pkg_grps(self):
+        fo = _open_no_umask(self.filename + '.tmp', 'w')
+
+        fo.write("1\n") # version
+        fo.write("%u\n" % len(self.groups))
+        for grp in sorted(self.groups.values()):
+            fo.write("%s\n" % grp.gid)
+            fo.write("%u\n" % len(grp.pkg_names))
+            for pkgname in sorted(grp.pkg_names):
+                fo.write("%s\n" % pkgname)
+        fo.close()
+        os.rename(self.filename + '.tmp', self.filename)
+
+    def _write_grp_grps(self):
+        fo = _open_no_umask(self.grp_filename + '.tmp', 'w')
+
+        fo.write("1\n") # version
+        fo.write("%u\n" % len(self.environments))
+        for evgrp in sorted(self.environments.values()):
+            fo.write("%s\n" % evgrp.evgid)
+            fo.write("%u\n" % len(evgrp.grp_names))
+            for grpname in sorted(evgrp.grp_names):
+                fo.write("%s\n" % grpname)
+                if (grpname in self.groups and
+                    self.groups[grpname].environment == evgrp.evgid):
+                    fo.write("%s\n" % "true")
+                else:
+                    fo.write("%s\n" % "false")
+
+        fo.close()
+        os.rename(self.grp_filename + '.tmp', self.grp_filename)
+
+    def add_group(self, groupid, pkg_names, ievgrp=None):
+        self.changed = True
+
+        if groupid not in self.groups:
+            self.groups[groupid] = InstalledGroup(groupid)
+        grp = self.groups[groupid]
+
+        for pkg_name in pkg_names:
+            grp.pkg_names.add(pkg_name)
+
+        if ievgrp is not None:
+            grp.environment = ievgrp.evgid
+            ievgrp.grp_names.add(groupid)
+        return grp
+
+    def del_group(self, groupid):
+        self.changed = True
+
+        if groupid in self.groups:
+            del self.groups[groupid]
+
+    def return_groups(self, group_pattern, case_sensitive=False):
+        returns = {}
+
+        if not group_pattern:
+            return []
+
+        for item in group_pattern.split(','):
+            item = item.strip()
+            if item in self.groups:
+                thisgroup = self.groups[item]
+                returns[thisgroup.gid] = thisgroup
+                continue
+            
+            if case_sensitive:
+                match = re.compile(fnmatch.translate(item)).match
+            else:
+                match = re.compile(fnmatch.translate(item), flags=re.I).match
+
+            done = False
+            for group in self.groups.values():
+                if match(group.gid):
+                    done = True
+                    returns[group.gid] = group
+                    break
+
+        return returns.values()
+
+    def add_environment(self, evgroupid, grp_names):
+        self.changed = True
+
+        if evgroupid not in self.environments:
+            self.environments[evgroupid] = InstalledEnvironment(evgroupid)
+        grp = self.environments[evgroupid]
+
+        for grp_name in grp_names:
+            grp.grp_names.add(grp_name)
+        return grp
+
+    def del_environment(self, evgroupid):
+        self.changed = True
+
+        if evgroupid in self.environments:
+            del self.environments[evgroupid]
+
+    def return_environments(self, evgroup_pattern, case_sensitive=False):
+        returns = {}
+
+        if not evgroup_pattern:
+            return []
+
+        for item in evgroup_pattern.split(','):
+            item = item.strip()
+            if item in self.environments:
+                thisgroup = self.environments[item]
+                returns[thisgroup.evgid] = thisgroup
+                continue
+
+            if case_sensitive:
+                match = re.compile(fnmatch.translate(item)).match
+            else:
+                match = re.compile(fnmatch.translate(item), flags=re.I).match
+
+            done = False
+            for group in self.environments.values():
+                if match(group.evgid):
+                    done = True
+                    returns[group.evgid] = group
+                    break
+
+        return returns.values()
